import { PaddingMode } from '@tensorflow/tfjs-layers/dist/common';
import { Layer } from '@tensorflow/tfjs-layers/dist/engine/topology';
import { ConvLayerConfig } from '@tensorflow/tfjs-layers/dist/layers/convolutional';
import { onnx } from 'onnx-proto';
import { OnnxNode } from '../node';
export declare type AutoPad = 'SAME_UPPER' | 'SAME_LOWER' | 'VALID';
export interface ConvNodeConfig {
    auto_pad?: onnx.AttributeProto;
    dilations?: onnx.AttributeProto;
    group?: onnx.AttributeProto;
    kernel_shape?: onnx.AttributeProto;
    pads?: onnx.AttributeProto;
    strides?: onnx.AttributeProto;
}
export declare class Conv extends OnnxNode {
    static getTfjsPadding(pads: number[], auto_pad: AutoPad): PaddingMode;
    static getConvDim(node: onnx.INodeProto): number;
    getTfjsLayerConfig(node: onnx.INodeProto): ConvLayerConfig;
    getTfjsLayer(node: onnx.INodeProto): Layer;
}
