import { Layer } from '@tensorflow/tfjs-layers/dist/engine/topology';
import { DenseLayerConfig, DropoutLayerConfig } from '@tensorflow/tfjs-layers/dist/layers/core';
import { onnx } from 'onnx-proto';
import { OnnxNode } from '../node';
export interface FCNodeConfig {
    axis?: onnx.AttributeProto;
    axis_w?: onnx.AttributeProto;
}
export declare class Dense extends OnnxNode {
    getTfjsLayerConfig(node: onnx.INodeProto): DenseLayerConfig;
    getTfjsLayer(node: onnx.INodeProto): Layer;
}
export interface DropoutNodeConfig {
    is_test?: onnx.AttributeProto;
    ratio?: onnx.AttributeProto;
}
export declare class Dropout extends OnnxNode {
    getTfjsLayerConfig(node: onnx.INodeProto): DropoutLayerConfig;
    getTfjsLayer(node: onnx.INodeProto): Layer;
}
